<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>ImportedRegisterFileDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/voting-material/register/register-list.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(data: <a href="../interfaces/ImportedRegisterFile.html">BehaviorSubject<ImportedRegisterFile[]></a>, sort: MatSort)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="111" class="link-to-prism">src/app/operation/voting-material/register/register-list.component.ts:111</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>data</td>
                                                  
                                                        <td>
                                                                    <code><a href="../interfaces/ImportedRegisterFile.html" target="_self" >BehaviorSubject&lt;ImportedRegisterFile[]&gt;</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>sort</td>
                                                  
                                                        <td>
                                                                    <code>MatSort</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>


            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="117" class="link-to-prism">src/app/operation/voting-material/register/register-list.component.ts:117</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code>Observable&lt;any[]&gt;</code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="124" class="link-to-prism">src/app/operation/voting-material/register/register-list.component.ts:124</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, Input, OnDestroy, OnInit, ViewChild } from &quot;@angular/core&quot;;
import { MatSort } from &quot;@angular/material&quot;;
import { BehaviorSubject } from &quot;rxjs/BehaviorSubject&quot;;
import { ActivatedRoute, Router } from &quot;@angular/router&quot;;
import { DataSource } from &quot;@angular/cdk/collections&quot;;
import { Observable } from &quot;rxjs/Observable&quot;;
import { TdDialogService } from &quot;@covalent/core&quot;;
import { TranslateService } from &quot;@ngx-translate/core&quot;;
import { Operation } from &quot;../../model/operation&quot;;
import { sortOnProperty } from &quot;../../../core/util/table-utils&quot;;
import { ImportedRegisterFile } from &quot;./model/imported-register-file&quot;;
import { RegisterService } from &quot;./services/register.service&quot;;
import { OperationManagementService } from &#x27;../../service/operation-managment.service&#x27;;
import { map, merge } from &#x27;rxjs/operators&#x27;;
import { AuthorizationService } from &#x27;../../../core/service/http/authorization.service&#x27;;
import { ReadOnlyService } from &#x27;../../service/read-only.service&#x27;;
import { Subscription } from &#x27;rxjs/Subscription&#x27;;

@Component({
  selector: &#x27;register-list&#x27;,
  templateUrl: &#x27;./register-list.component.html&#x27;,
  styleUrls: [&#x27;./register-list.component.scss&#x27;]
})
export class RegisterListComponent implements OnInit, OnDestroy {
  dataSource: ImportedRegisterFileDataSource;
  @Input()
  operation: Operation;
  importedRegisterFiles &#x3D; new BehaviorSubject&lt;ImportedRegisterFile[]&gt;([]);
  @ViewChild(MatSort) sort: MatSort;
  private _subscriptions: Subscription[] &#x3D; [];

  constructor(private route: ActivatedRoute,
              private dialogService: TdDialogService,
              private translateService: TranslateService,
              private router: Router,
              private operationManagementService: OperationManagementService,
              private authorizationService: AuthorizationService,
              private readOnlyService: ReadOnlyService,
              private registerService: RegisterService) {
  }

  private _readOnly &#x3D; false;

  get readOnly(): boolean {
    return this._readOnly;
  }

  get displayedColumns() {

    return [&quot;managementEntity&quot;, &quot;fileName&quot;, &quot;uploadDetails&quot;, &quot;statistics&quot;]
      .concat(this.readOnly || !this.authorizationService.hasAtLeastOneRole([&#x27;DELETE_REGISTER_FILE&#x27;]) ? [] : [&quot;delete&quot;])
      .concat(this.authorizationService.hasAtLeastOneRole([&#x27;GET_REGISTER_REPORT&#x27;]) ? [&quot;detailedReport&quot;] : []);
  }

  get registerCount(): number {
    let registers &#x3D; this.importedRegisterFiles.getValue();
    return registers ? registers.length : 0;
  }

  ngOnDestroy(): void {
    this._subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }

  ngOnInit() {
    this.registerService.getReports(this.operation.id).subscribe(reports &#x3D;&gt; this.importedRegisterFiles.next(reports));
    this.dataSource &#x3D; new ImportedRegisterFileDataSource(this.importedRegisterFiles, this.sort);
    this._subscriptions.push(
      this.readOnlyService.isRegisterInReadOnly().subscribe(readOnly &#x3D;&gt; this._readOnly &#x3D; readOnly));

  }

  getReport(messageUniqueId) {
    this.registerService.downloadReport(messageUniqueId, this.operation.id);
  }

  getConsolidatedReport() {
    this.registerService.downloadConsolidatedReport(this.operation.id);
  }

  remove(messageUniqueId, fileName) {
    this.dialogService.openConfirm({
      message: this.translateService.instant(&#x27;voting-material.register.delete-dialog.message&#x27;, {fileName: fileName}),
      disableClose: true,
      cancelButton: this.translateService.instant(&#x27;global.actions.no&#x27;),
      acceptButton: this.translateService.instant(&#x27;global.actions.yes&#x27;),
    }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
      if (accept) {
        this.registerService.remove(this.operation.id, messageUniqueId)
          .subscribe(() &#x3D;&gt; {
            this.importedRegisterFiles.next(
              this.importedRegisterFiles.getValue().filter((rf) &#x3D;&gt; rf.messageUniqueId !&#x3D; messageUniqueId));
          });
        this.operationManagementService.shouldUpdateStatus();
      }
    });
  }

  uploadRegister() {
    this.router.navigate([&#x27;upload&#x27;], {relativeTo: this.route});
  }

  userManagementEntityCanDelete(element: ImportedRegisterFile) {
    const userManagementEntity &#x3D; this.authorizationService.userSnapshot.managementEntity;
    return element.managementEntity &#x3D;&#x3D;&#x3D; userManagementEntity ||
           this.operation.managementEntity &#x3D;&#x3D;&#x3D; userManagementEntity;
  }


}

class ImportedRegisterFileDataSource extends DataSource&lt;any&gt; {

  constructor(private data: BehaviorSubject&lt;ImportedRegisterFile[]&gt;, private sort: MatSort) {
    super();
  }

  connect(): Observable&lt;any[]&gt; {
    return this.data.pipe(
      merge(this.sort.sortChange),
      map(() &#x3D;&gt; sortOnProperty(this.data.getValue(), this.sort.active, this.sort.direction))
    );
  }

  disconnect() {
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'ImportedRegisterFileDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
